//--------------------
// doNothing()
//--------------------

function doNothing() { }

//--------------------
// AsciiOnly()
//--------------------

function AsciiOnly(evt)
{
	var k;
	if (gIsNS6) {
		k = evt.charCode;
		if (k>127 || k==13) evt.preventDefault();
	}
	else {
		k = evt.keyCode;
		if (k>127 || k==13) evt.returnValue = false;
	}

	return k;
}

//--------------------
// CancelBubble()
//--------------------

function CancelBubble(evt)
{
	if (gIsNS6) evt.preventBubble();
	else evt.cancelBubble = true;

	return true;
}

//--------------------
// EnumProps()
//--------------------

function EnumProps(obj)
{
	var i;
	for (i in obj) alert("obj." + i + "=" + eval("obj." + i));
}

//--------------------
// Array()  extensions
//--------------------

function ArrayAppend(inObj)
{
	this[this.numItems] = inObj;
	return this.numItems++;
}

function ArrayAppendOwn(inObj)
{
	inObj.myOwner = this.myOwner;
	inObj.indexNum = this.numItems;

	this[this.numItems] = inObj;
	return this.numItems++;
}

function ArrayIsValid(inIndex)
{
	return (inIndex < this.numItems) ? true : false;
}

function ArrayRemAll()
{
	this.numItems = 0;
}

function ArrayRem(obj)
{
	var i;
	var ii = 1;
	var f = false;
	var iMax = this.numItems;
	for (i=0; i < iMax; i++) {
		if (this[i] == obj) f = true;
		if (f && (ii < iMax)) this[i] = this[ii];
		ii++;
	}
	if (f) this.numItems--;

	return f;
}

Array.prototype.numItems = 0;
Array.prototype.Append = ArrayAppend;
Array.prototype.AppendOwn = ArrayAppendOwn;
Array.prototype.IsValid = ArrayIsValid;
Array.prototype.RemoveAll = ArrayRemAll;
Array.prototype.Remove = ArrayRem;


//--------------------------------------
//	ObjShow(), ObjHide()
//--------------------------------------

function ObjShow()
{
	this.style.visibility = "inherit";
	if (typeof(this.cleanColor)!="undefined") forceRepaint(this,this.cleanColor); //BRIAN: NS6 doesn't always repaint completely.
}

function ObjHide()
{
	this.style.visibility = "hidden";

	//BRIAN: NS6 doesn't always repaint completely.
	if (!gIsIE4&&(typeof(this.cleanColor)!="undefined")) forceRepaint(gWizObj.curCtlr.logMgr.childNodes[0].childNodes[0].childNodes[1],"#e6edfa");
}


//--------------------------------------
//	GetPageElement()
//--------------------------------------

function GetPageElement(id, errOk)
{
	var obj = null;
	if (document.getElementById) {
		obj = document.getElementById(id);
	}
	else if (document.all) {
		obj = eval("document.all." + id);
	}
	else {
		alert("Unsupported browser");
	}

	if (!obj && !errOk) {
		alert("Error getting page element: " + id);
	}

	return obj;
}

//--------------------------------------
//	FrameObj()
//--------------------------------------

function FrameObj()
{
	var c;
	if (this.childNodes) {
		c = this.childNodes;
		this.topImg = c[0].childNodes[0].childNodes[1];
		this.midImg = c[1].childNodes[0].childNodes[1];
		this.btmImg = c[2].childNodes[0].childNodes[1];
		this.leftImg = c[1].childNodes[0].childNodes[0];
		this.rightImg = c[1].childNodes[0].childNodes[2];
	}
	else {
		c = this.children;
		this.topImg = c[0].children[0].children[1];
		this.midImg = c[1].children[0].children[1];
		this.btmImg = c[2].children[0].children[1];
		this.leftImg = c[1].children[0].children[0];
		this.rightImg = c[1].children[0].children[2];
		this.frameX = this.leftImg.offsetWidth + this.rightImg.offsetWidth;
		this.frameY = this.topImg.offsetHeight + this.btmImg.offsetHeight;
	}

	this.SetSize = FrameSetSize;
	this.SetHeight = FrameSetHeight;
	this.SetWidth = FrameSetWidth;
}

function GetFrameObj(objName)
{
	var obj = GetPageElement(objName);
	if (obj) {
		obj.frameObj = FrameObj;
		obj.frameObj();
	}

	return obj;
}

function FrameSetSize(inW, inH)
{
	this.topImg.width = inW;
	this.midImg.width = inW;
	this.btmImg.width = inW;
	this.leftImg.height = inH;
	this.rightImg.height = inH;
	if (!this.childNodes) this.style.width = inW + this.frameX + "px";
}

function FrameSetWidth(inW)
{
	this.topImg.width = inW;
	this.midImg.width = inW;
	this.btmImg.width = inW;
	if (!this.childNodes) this.style.width = inW + this.frameX + "px";
}

function FrameSetHeight(inH)
{
	this.leftImg.height = inH;
	this.rightImg.height = inH;
}

//--------------------------------------
//	Btn2Obj()
//--------------------------------------

function Btn2Obj()
{
	var w;
	var c;
	if (this.childNodes) {
		c = this.childNodes;
		w = c[3].childNodes[0].offsetWidth;
		this.midOff = c[0].childNodes[0].childNodes[1];
		this.midOn = c[1].childNodes[0].childNodes[1];
	}
	else {
		c = this.children;
		w = c[3].children[0].offsetWidth;
		this.midOff = c[0].children[0].children[1];
		this.midOn = c[1].children[0].children[1];
	}
	this.onImg = c[1];
	this.textDiv = c[3];
	this.topImg = c[4];

	this.isOn = false;
	this.topImg.myOwner = this;

	if (!c[2].offsetLeft) c[2].style.left = c[3].offsetLeft + w + "px"; // put image to the right of the text
	w += c[2].offsetWidth;
	this.SetMidSize = BtnSetMidSize;
	this.SetMidSize(w);
	this.ySize = this.topImg.offsetHeight;

	this.SetOn = BtnSetOn;
	this.SetOff = BtnSetOff;
	this.Show = ObjShow;
	this.Hide = ObjHide;
	this.eClick = ToggleBtn;
	this.eMouseOver = BtnTipInit;
	this.eMouseOut = BtnMouseOut;

	this.myTip = null;
	if (c.length >= 6) {
		this.myTip = c[5];
		//this.myTip.toolTip = ToolTip;
		//this.myTip.toolTip(0);
	}
}

function BtnSetMidSize(w)
{
	this.midSize = w;
	this.midOff.width = w;
	this.midOn.width = w;
	var c;
	if (this.childNodes) {
		c = this.childNodes[0].childNodes[0].childNodes;
		w += c[0].offsetWidth + c[2].offsetWidth;
	}
	else {
		c = this.children[3];
		c.style.width = c.children[0].offsetWidth + "px";
		c = this.children[0].children[0].children;
		w += c[0].offsetWidth + c[2].offsetWidth;
		this.style.width = w + "px";
	}
	this.topImg.width = w;
	this.xSize = w;
}

function BtnSetOn()
{
	this.onImg.style.visibility = "inherit";
	this.isOn = true;
}

function BtnSetOff()
{
	this.onImg.style.visibility = "hidden";
	this.isOn = false;
}

function BtnMouseOver()
{
	if (this.myTip) gCmdTipMgr.Start(this);
}

function BtnMouseOut()
{
	if (this.myTip) gCmdTipMgr.Stop(this);
}

function ToggleBtn(evt)
{
	if (this.isOn) this.SetOff();
	else this.SetOn();

	if (this.myTip) gCmdTipMgr.Stop(this);
	return true;
}

function BtnTipInit()
{
	var t = this.myTip;
	if (t) {
		t.toolTip = ToolTip;
		t.toolTip(0);
	}

	this.eMouseOver = BtnMouseOver;
	this.eMouseOver();
}


//--------------------------------------
//	Btn3Obj()
//--------------------------------------

function Btn3Obj()
{
	var c = (this.childNodes) ? this.childNodes : this.children;
	this.onImg = c[1];
	this.topImg = c[2];
	this.topImg.myOwner = this;
	this.xSize = this.onImg.offsetWidth;
	this.ySize = this.onImg.offsetHeight;
	this.isOn = false;

	this.SetOn = BtnSetOn;
	this.SetOff = BtnSetOff;
	this.Show = ObjShow;
	this.Hide = ObjHide;
	this.eClick = ToggleBtn;
	this.eMouseOver = BtnTipInit;
	this.eMouseOut = BtnMouseOut;

	this.myTip = null;
	if (c.length >= 4) {
		this.myTip = c[3];
		//this.myTip.toolTip = ToolTip;
		//this.myTip.toolTip(0);
	}
}


//--------------------------------------
//	ToolTip()
//--------------------------------------

function ToolTip(initSize)
{
	if (this.childNodes) {
		this.myContent = this.childNodes[0];
		this.myBubble = this.childNodes[1];
	}
	else {
		this.myContent = this.children[0];
		this.myBubble = this.children[1];
	}
	this.SetContent = ToolTipSetContent;
	this.SyncSize = ToolTipSyncSize;
	this.Show = ObjShow;
	this.Hide = ObjHide;

	this.ySize = initSize;
	this.SyncSize();
}

function ToolTipSetContent(inContent)
{
	this.myContent.innerHTML = inContent;
	this.SyncSize();
}

function ToolTipSyncSize()
{
	var oh = this.myContent.offsetHeight - 1;
	var sz = oh + this.myBubble.offsetHeight;
	var deltaY = sz - this.ySize;
	if (deltaY) {
		this.style.top = this.offsetTop - deltaY + "px";
		this.myBubble.style.top = oh + "px";
	}
	this.style.width = this.myContent.offsetWidth + "px";
	this.ySize = sz;
}


//--------------------------------------
// TipMgrObj()
//--------------------------------------

var gDevTipMgr = new TipMgrObj();
var gCmdTipMgr = new TipMgrObj();

function TipMgrObj()
{
	this.curObj = null;
	this.cntr = 0;
	this.delay = 0;

	this.Start = StartTip;
	this.Stop = StopTip;
	this.Check = CheckTip;
}

function CheckTip()
{
	if (this.cntr >= this.delay) {
		this.curObj.myTip.style.visibility = "inherit";
		this.curObj = null;
	}
	else {
		this.cntr++;
	}
}

function StartTip(inObj)
{
	if (!this.delay) {
		toggleLogMgr(inObj,0); //BRIAN: IE4 mis-layers the PhysMgr and LogMgr.
		inObj.myTip.style.visibility = "inherit";
	}
	else if (this.delay < 100) {
		this.cntr = 0;
		this.curObj = inObj;
	}
}

function StopTip(inObj)
{
	inObj.myTip.style.visibility = "hidden";
	toggleLogMgr(inObj,1000); //BRIAN: IE4 mis-layers the PhysMgr and LogMgr.
	this.curObj = null;
}

function toggleLogMgr(anElement,zIndex) //BRIAN: IE4 mis-layers the PhysMgr and LogMgr.
{
	if (!gIsIE4) return;

	for ( ; anElement; anElement=anElement.parentElement) {
		if (!anElement.id.indexOf("baa"))
		{
			anElement.parentElement.children[0].style.zIndex=zIndex;
			return;
		}
	}
}
